<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">DANH SÁCH LIÊN HỆ</h2>
        <table class="table text-center table-striped table table-bordered" id="table-order">
            <thead>
                <tr>
                    <th scope="col" class="bg-primary text-white">STT</th>
                    <th scope="col" class="bg-primary text-white">NAME</th>
                    <th scope="col" class="bg-primary text-white">EMAIL</th>
                    <th scope="col" class="bg-primary text-white">MESSAGE</th>
                    <th scope="col" class="bg-primary text-white">NGÀY LIÊN HỆ</th>
                    <th scope="col" class="bg-primary text-white">ACTION</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 là tạo mới thành công
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gEND_OF_ROW_COL = -1;
    const gCOL_STT = 0;
    const gCOL_NAME = 1;
    const gCOL_EMAIL = 2;
    const gCOL_MESSAGE = 3;
    const gCOL_DATE = 4;
    const gCOL_ACTION = 5;
    var gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm thực hiện khi load trang
    function onPageLoading() {
        var vXhttp = new XMLHttpRequest();
        getContactList(vXhttp);
        vXhttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXhttp.responseText); // ghi response text ra console.log
                loadDataToForm(vXhttp);
            }
        };
    }
    function onBtnSuaClick(paramSuaClick) {
        var vId = paramSuaClick.dataset.id;
        console.log(vId);
    }
    function onBtnXoaClick(paramXoaClick) {
        var vId = paramXoaClick.dataset.id;
        console.log(vId);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function getContactList(paramXmlHttp) {
        var vAPI_URL = gBASE_URL + "/contacts";
        paramXmlHttp.open("GET", vAPI_URL, true);
        paramXmlHttp.send();
    }
    function loadDataToForm(paramXmlHttp) {
        var vContactJsonObj = JSON.parse(paramXmlHttp.responseText);
        var vOrderTable = document.getElementById("table-order");
        var vTableTbody = document.getElementsByTagName("tbody")[0];
        for (var bI = 0; bI < vContactJsonObj.length; bI++) {
            var bNewRow = vTableTbody.insertRow(gEND_OF_ROW_COL);
            var bSTT = bNewRow.insertCell(gCOL_STT);
            var bName = bNewRow.insertCell(gCOL_NAME);
            var bEmail = bNewRow.insertCell(gCOL_EMAIL);
            var bMessage = bNewRow.insertCell(gCOL_MESSAGE);
            var bDate = bNewRow.insertCell(gCOL_DATE);
            var bAction = bNewRow.insertCell(gCOL_ACTION);
            bSTT.innerHTML = bI + 1;
            bName.innerHTML = vContactJsonObj[bI].name;
            bEmail.innerHTML = vContactJsonObj[bI].email;
            bMessage.innerHTML = vContactJsonObj[bI].message;
            bDate.innerHTML = vContactJsonObj[bI].createDate;
            var bSuaButton = document.createElement("button");
            var bXoaButton = document.createElement("button");
            bSuaButton.textContent = "Sửa";
            bSuaButton.className = "btn btn-success oder-detail";
            bSuaButton.setAttribute("data-id", vContactJsonObj[bI].id);
            bXoaButton.textContent = "Xóa";
            bXoaButton.className = "btn btn-danger oder-detail";
            bXoaButton.setAttribute("data-id", vContactJsonObj[bI].id);
            bAction.appendChild(bSuaButton);
            bAction.appendChild(bXoaButton);
            bSuaButton.addEventListener("click", function () {
                onBtnSuaClick(this)
            });
            bXoaButton.addEventListener("click", function () {
                onBtnXoaClick(this)
            });
        }
    }
</script>

</html>